<?php

namespace App\Controller;


use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;


use App\Entity\Donnee;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;

class DonneeM2Controller
{

    private $em;

    public function __construct(EntityManagerInterface $em) {
        $this->em = $em;
    }

    public function __invoke(Request $data)
    {
        $query = "  SELECT AVG(data.valeurFonciere/data.surface) as moyenne_surface, DATE_TRUNC('month', data.dateMutation) month
                    FROM App:Donnee AS data
                    WHERE data.surface > 0 AND data.valeurFonciere > 0
                    GROUP BY month";

        $resQuery = $this->em->createQuery($query)->getResult();

        $moyenneParMois = array();
        foreach ($resQuery as $donnee) {
            $moyenneParMois['month'] = floatval($donnee['moyenne_surface']);
        }

        $listeReponse = array();
        foreach ($moyenneParMois as $key => $moyenne) {
            $listeReponse[$key] = $moyenne;
        }

        return new JsonResponse($listeReponse);
    }
}
